Subject: RE: [Sip] RFC 3261 section 17.1.1.2 INVITE Client transaction StateMachine

From: <[email-masked]>
Date: Wed, 27 Sep 2006 20:00:52 +0530

Hi,
Refer Bug 706 @
http://bugs.sipit.net/show_bug.cgi?id=706

HTH,
Sreeram.

-----Original Message-----
From: Nayak, Subhransu S [mailto:[email-masked]] 
Sent: Wednesday, September 27, 2006 7:45 PM
To: [email-masked]
Subject: [Sip] RFC 3261 section 17.1.1.2 INVITE Client transaction
StateMachine

There is an obvious flaw in the INVITE client transaction state machine.
Once in "proceeding" state, State Machine is purely driven by the peer's
response to the INVITE. If peer goes down, then  INVITE client
transaction gets stuck in the "proceeding" state forever. From an
implementation's perspective, when does the TU in an UAC release the
transaction resource in this case ?   

                   |INVITE from TU
             Timer A fires     |INVITE sent
             Reset A,          V                      Timer B fires
             INVITE sent +-----------+                or Transport Err.
               +---------|           |---------------+inform TU
               |         |  Calling  |               |
               +-------->|           |-------------->|
                         +-----------+ 2xx           |
                            |  |       2xx to TU     |
                            |  |1xx                  |
    300-699 +---------------+  |1xx to TU            |
   ACK sent |                  |                     |
resp. to TU |  1xx             V                     |
            |  1xx to TU  -----------+               |
            |  +---------|           |               |
            |  |         |Proceeding |-------------->|
            |  +-------->|           | 2xx           |
            |            +-----------+ 2xx to TU     |
            |       300-699    |                     |
            |       ACK sent,  |                     |
            |       resp. to TU|                     |
            |                  |                     |      NOTE:
            |  300-699         V                     |
            |  ACK sent  +-----------+Transport Err. |  transitions
            |  +---------|           |Inform TU      |  labeled with
            |  |         | Completed |-------------->|  the event
            |  +-------->|           |               |  over the action
            |            +-----------+               |  to take
            |              ^   |                     |
            |              |   | Timer D fires       |
            +--------------+   | -                   |
                               |                     |
                               V                     |
                         +-----------+               |
                         |           |               |
                         | Terminated|<--------------+
                         |           |
                         +-----------+

                 Figure 5: INVITE client transaction

Thanks,
- Subhransu 

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip